diff --git a/CMakeLists.txt b/CMakeLists.txt
index 60daa8b2..12a7d74a 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -2,6 +2,7 @@ cmake_minimum_required(VERSION 3.13.4)
 
 include(CheckSymbolExists)
 
+option(TEST_SUITE_CLANGIR_ENABLE "Run tests through ClangIR" OFF)
 
 project(test-suite C CXX)
 
diff --git a/SingleSource/CMakeLists.txt b/SingleSource/CMakeLists.txt
index 21cae5c2..6c8e4641 100644
--- a/SingleSource/CMakeLists.txt
+++ b/SingleSource/CMakeLists.txt
@@ -1,3 +1,11 @@
+if (TEST_SUITE_CLANGIR_ENABLE)
+  message(STATUS "Enabling ClangIR for SingleSource tests")
+  add_compile_options(
+    $<$<COMPILE_LANGUAGE:C>:-fclangir-enable>
+    $<$<COMPILE_LANGUAGE:CXX>:-fclangir-enable>
+  )
+endif()
+
 add_subdirectory(Benchmarks)
 if(NOT TEST_SUITE_BENCHMARKING_ONLY)
   add_subdirectory(UnitTests)
